%%

clc;
clear all;
% close all;

%%   repeat count Ѵ.
repCnt1  = 1; % <== ̸ŭ  measureѴ. 
repCnt2  = 10; % <== ̸ŭ  measureѴ. 

%%
% predict  Ѵ. 
Zstart  = 0;
Zend    = 10;
Zres    = 50;
pred.Z  = linspace(Zstart, Zend, Zres)';

% measurement Ѵ. 
meas.X  = [3*ones(repCnt1, 1) ; 7*ones(repCnt2, 1)];
meas.Y  = [1*ones(repCnt1, 1) ; -1*ones(repCnt2, 1)];
meas.Y  = meas.Y + 1E-2*randn(size(meas.Y));

%%  kernel  
option.useSE_K = 1;
option.display = 1;
%% Estimating Hyperparameter
doEstimateHyperparam = 0;
if doEstimateHyperparam
    fprintf(1, 'starting Hyperparamter estimation... \n');
    hyp = sjHyperEstimate(meas.X, meas.Y, option);
    fprintf(1, '...done \n');
    save('1d_gp_param', 'hyp');
else
    load('1d_gp_param');
end

option.sigma2w  = hyp.sigma2w;
option.sigma2f  = hyp.sigma2f;
option.sigma2x  = hyp.sigma2x;

%% Do Gaussian Process 
fprintf(1, 'starting Gausian Process... \n');
[zhatxstar sigma2xstar] = sjGP(pred.Z , meas.X, meas.Y, option);
fprintf(1, '...done \n');

%% PLOT Ѵ.  
figure();
hold on;
plot(meas.X, meas.Y, 'bo');
plot(pred.Z, zhatxstar, 'r-');
plot(pred.Z, zhatxstar-sigma2xstar/2, 'g--');
plot(pred.Z, zhatxstar+sigma2xstar/2, 'g--');
legend('Measurement', 'GP prediction', 'GP variance');
hold off;
axis([Zstart Zend -1.3 1.3]);
title(['Gaussian Process Regression with ' ...
    num2str(repCnt1) '/' num2str(repCnt2) ' repeat']);

%%

