
function [ref, meas, pred, nr_agents] ...
    = make_gp_measurements(test_index, nr_agents, field, stage, param, make_new, plot_new)

% ͸    ҷ  
make_new_meas = make_new;  

%  plot  
plot_realization_and_measurement = 0;

%%
if make_new_meas 
    
    fprintf(1, 'Make new measurements and save to RefMeas_%d.mat \n' ...
        , test_index );
    
    %% 1. refernce data Ѵ.
    random_position     = 1;
    uniform_position    = 0;
    
    % 1.  ġ
    if random_position
        ref.pos               = [ field.xmin + (field.xmax - field.xmin)*rand(nr_agents, 1) ...
            field.ymin + (field.ymax - field.ymin)*rand(nr_agents, 1) ];
    end
    
    % 2. Uniformϰ ġ
    if uniform_position
        field_w  = 3;
        field_h  = nr_agents / field_w;
        xs       = linspace(field.xmin, field.xmax, field_w+2);
        ys       = linspace(field.ymin, field.ymax, field_h+2);
        xs       = xs(2:field_w+1);
        ys       = ys(2:field_h+1);
        [fx, fy] = meshgrid(xs, ys);
        ref.pos = [fx(:) fy(:)];
    end
    
    ref.data              = zeros(nr_agents, 1);
    for ni = 1:nr_agents
        %  agent ش ġ measurement Ѵ.
        x_curr          = ref.pos(ni, 1);
        y_curr          = ref.pos(ni, 2);
        ref.data(ni)    = interp2(field.xgrid, ...
            flipud(field.ygrid), field.zdata, ...
            x_curr, y_curr );
    end
    
    % 2. measurement data Ѵ.
    meas.data           = ref.data + sqrt(param.sigma2_obs_y)*randn(size(ref.data));
    for ni = 1:nr_agents
        while 1
            meas.pos(ni, :)     = ref.pos(ni, :) + sqrt(param.sigma2_obs_x)*randn(1, 2);
            if field.xmin <= meas.pos(ni, 1) && meas.pos(ni, 1) <= field.xmax ...
                    && field.ymin <= meas.pos(ni, 2) && meas.pos(ni, 2) <= field.ymax
                break;
            end
        end
    end
    
    % 3. prediction points Ѵ.
    pred.pos = [reshape(field.xgrid, [], 1), reshape(flipud(field.ygrid), [], 1)];
    
    % 4. Ѵ.
    save(['data/RefMeas_' num2str(test_index) '.mat'] ...
        , 'ref', 'meas', 'pred', 'nr_agents' );
    
else
    %% 
        
    load(['data/RefMeas_' num2str(test_index) '.mat'] );
    
    fprintf(1, 'Load existing measurements from RefMeas_%d.mat \n' ...
        , test_index );
    
end


%% ׽Ʈ ؼ ׸ ׷.
if plot_new
    %%
    %  Field ׸,
    figure();pcolor(stage.xgrid, stage.ygrid, field.zdata);
    set(gca,'YDir','normal');  % ߿! <= Matrix Graph y  ݴ̴.
    colorbar; caxis([field.zmin field.zmax]); hold on;
    shading interp;lighting phong;
    % ׸ Ʈ, ش field  ׸.
    for ei = 1:nr_agents
        hold on;
        
        for ej = ei+1:nr_agents
            pos_i = ref.pos(ei,:);
            pos_j = ref.pos(ej,:);
            dist_ij = norm(pos_i-pos_j);
            if dist_ij < param.radiusKernel
%                 plot( [pos_i(1) pos_j(1)] , [pos_i(2) pos_j(2)] ,'w-', 'LineWidth', 2);
            end
        end
        
        h_ref = plot(ref.pos(ei, 1), ref.pos(ei, 2), 'o', 'LineWidth',2,...
            'MarkerEdgeColor','g',...
            'MarkerFaceColor','w',...
            'MarkerSize',10, 'LineWidth', 3);
        
        h_meas = plot(meas.pos(ei, 1), meas.pos(ei, 2), 'o', 'LineWidth',2,...
            'MarkerEdgeColor','k',...
            'MarkerSize',10, 'LineWidth', 3);
                
        str = sprintf('   [%d] %.3f', ei, meas.data(ei));
        text(meas.pos(ei, 1), meas.pos(ei, 2), str);
        
        hold off;
    end
    legend([h_ref h_meas], 'Real position', 'Measurement position', 4);
    title('Gaussain Process Realization and Estimates');  
    
    
end














