function [field, pred] ...
    = sjGaussinProcessRealization(x_min, x_max, x_grid_resol, y_min, y_max, y_grid_resol, option_gp)

% x_grid_resol    = 21;        % <== 
% y_grid_resol    = 21;        % <== 
% x_min           = 0;
% x_max           = 1;
% y_min           = 0;
% y_max           = 1;

x       = linspace(x_min, x_max, x_grid_resol);
y       = linspace(y_min, y_max, y_grid_resol);
[X,Y]   = meshgrid(x, y); 
mesh    = [X(:) Y(:)]; % 2-D mesh
n       = size(mesh, 1);

%%
K       = sjGP_kernel(mesh, mesh, option_gp) + sqrt(option_gp.sigma2w)*eye(n, n);
z       = chol(K)'*randn(n,1);
Z       = reshape(z, y_grid_resol, x_grid_resol);

field       = [];
field.Xgrid = X;
field.Ygrid = Y;
field.Zdata = Z - mean(mean(Z));
field.Xres = x_grid_resol;
field.Yres = y_grid_resol;
field.Xmin = x_min;
field.Xmax = x_max;
field.Ymin = y_min;
field.Ymax = y_max; 

%%
pred.pos  = [reshape(field.Xgrid, [], 1), ...
    reshape(flipud(field.Ygrid), [], 1)];

